﻿// ------------------------------------------------ ------------------
// | Lukas1 arrows & curves.mq4 v.28
// | Copyright © 2007, Lukashuk Victor G. aka lukas1
// ------------------------------------------------ ------------------
// 1. For the lines introduced by the delay, which leads to a shift to the right ("relay")
// 2. Appeared crosses denoting the closing of the transaction
// 3. Repeated orders in the same direction are marked as crosses
 
# Property copyright "Copyright © 2007, MetaQuotes Software Corp. Lukas1"
# Property link "lukas1@ngs.ru"
//----
# Property indicator_chart_window
# Property indicator_buffers 8
# Property indicator_color1 DeepSkyBlue
# Property indicator_color2 Red
# Property indicator_color3 Orange
# Property indicator_color4 Orange
# Property indicator_color5 MediumSeaGreen
# Property indicator_color6 MediumSeaGreen
 
# Property indicator_color7 DeepSkyBlue
# Property indicator_color8 Red
# Property indicator_width1 1
# Property indicator_width2 1
# Property indicator_width7 2
# Property indicator_width8 2
//---- Input parameters
extern int SSP = 20; // period linear reversal indicator
extern int Channel = 0, // decrease the range of the channel. Gb in the range of 0-50
extern int Ch_Stop = 30; // decrease in the stop channel (added to the principal)
extern int relay = 10, // offset lines back in history at 4 bar
extern int CBars = 2000; // billing period
int i;
double high, low, smin, smax, smin2, smax2;
double val1 []; // buffer to buy
double val2 []; // buffer to Sell
double BufferH [];
double BufferL [];
double BufferHS [];
double BufferLS [];
double valX1 [], valX2 []; // buffer for X
bool uptrend, old, uptrend2, old2;
/ / ------------------------------------------------ ------------------
/ / | Custom indicator initialization function |
/ / ------------------------------------------------ ------------------
int init ()
  {
   SetIndexStyle (0, DRAW_ARROW, 0,1);
   SetIndexArrow (0, 233) // pointer to buy
   SetIndexBuffer (0, val1); // index buffer to buy
   SetIndexLabel (0, "BUY");
   SetIndexDrawBegin (0, Bars-CBars-2 * SSP);
 
   SetIndexStyle (1, DRAW_ARROW, 0,1);
   SetIndexArrow (1, 234) // pointer to Sell
   SetIndexBuffer (1, val2); // index buffer to Sell
   SetIndexLabel (1, "SELL");
   SetIndexDrawBegin (1, Bars-CBars-2 * SSP);
 
   SetIndexStyle (2, DRAW_LINE, 0,1);
   SetIndexBuffer (2, BufferH);
   SetIndexLabel (2, "BUY from here");
   SetIndexDrawBegin (2, Bars-CBars-2 * SSP);
 
   SetIndexStyle (3, DRAW_LINE, 0,1);
   SetIndexBuffer (3, BufferL);
   SetIndexLabel (3, "SELL from here");
   SetIndexDrawBegin (3, Bars-CBars-2 * SSP);
 
   SetIndexStyle (4, DRAW_LINE, 0,1);
   SetIndexBuffer (4, BufferHS);
   SetIndexLabel (4, "BuyStop");
   SetIndexDrawBegin (4, Bars-CBars-2 * SSP);
 
   SetIndexStyle (5, DRAW_LINE, 0,1);
   SetIndexBuffer (5, BufferLS);
   SetIndexLabel (5, "SellStop");
   SetIndexDrawBegin (5, Bars-CBars-2 * SSP);
 
   SetIndexStyle (6, DRAW_ARROW, 0,2);
   SetIndexArrow (6, 251) // blue cross
   SetIndexBuffer (6, valX1); // index buffer for the cross
   SetIndexDrawBegin (6, Bars-CBars-2 * SSP);
 
   SetIndexStyle (7, DRAW_ARROW, 0,2);
   SetIndexArrow (7, 251) // red cross
   SetIndexBuffer (7, valX2); // index buffer for the cross
   SetIndexDrawBegin (7, Bars-CBars-2 * SSP);
 
//----
   return (0);
  }
/ / ------------------------------------------------ ------------------
/ / | Calculation of Channel lines
/ / ------------------------------------------------ ------------------
int start ()
  {
   int counted_bars = IndicatorCounted ();
//---- Last counted bar will be recounted
   if (counted_bars> 0) counted_bars -;
//----
   if (Bars <= SSP 1) return (0);
//----
   uptrend = false;
   old = false;
   uptrend2 = false;
   old2 = false;
   GlobalVariableSet ("goSELL", 0) // set the existence and zero goSELL = 0
   GlobalVariableSet ("goBUY", 0) // set the existence and zero goBUY = 0
   GlobalVariableSet ("stSELL", 0) // set the existence and zero stSELL = 0
   GlobalVariableSet ("stBUY", 0) // set the existence and zero stBUY = 0
//----
   for (i = CBars - SSP; i> = 0; i -) // decr the value shift by 1 per pass;
     {
       high = High [Highest (Symbol (), 0, MODE_HIGH, SSP, i relay)];
       low = Low [Lowest (Symbol (), 0, MODE_LOW, SSP, i relay)];
       smax = high - (high - low) * Channel / 100; // smax below the high, taking into account koeff.Channel
       smin = low (high - low) * Channel / 100; // smin above low given koeff.Channel
       smax2 = high - (high - low) * (Channel Ch_Stop) / 100; // smax below the high, taking into account koeff.Chan Ch_Stop
       smin2 = low (high - low) * (Channel Ch_Stop) / 100; // smin above low given koeff.Channel
        val1 [i] = 0;
       val2 [i] = 0;
       valX1 [i] = 0;
       valX2 [i] = 0;
//-----------------------
       if (Close [i] <smin & & Close [i] <smax & & uptrend2 == true & & i! = 0) // off blinking arrows (i! = 0)
         {
          uptrend = false;
         }
        if (Close [i]> smax & & Close [i]> smin & & uptrend2 == false & & i! = 0) // off blinking arrows (i! = 0)
          {
           uptrend = true;
         }
        if ((Close [i]> smax2 | | Close [i]> smin2) & & uptrend == false & & i! = 0) // off blinking arrows (i! = 0)
             {
              uptrend2 = false;
            }
       if ((Close [i] <smin2 | | Close [i] <smax2) & & uptrend == true & & i! = 0) // off blinking arrows (i! = 0)
            {
             uptrend2 = true;
            }
//---- Second signal toggles "uptrend"
//---- But the signal is used to cross
       if (Close [i] <smin & & Close [i] <smax & & uptrend2 == false & & i! = 0) // off blinking arrows (i! = 0)
         {
           val2 [i] = low; // if the conditions are fulfilled then draw val2
           if (i == 0) GlobalVariableSet ("goSELL", 1);
           uptrend2 = true;
         }
//---- Second signal toggles "uptrend"
//---- But the signal is used to cross
        if (Close [i]> smax & & Close [i]> smin & & uptrend2 == true & & i! = 0) // off blinking arrows (i! = 0)
         {
           val1 [i] = high; // if the conditions are fulfilled then draw val1
           if (i == 0) GlobalVariableSet ("goBUY", 1);
           uptrend2 = false;
         }
//----
       if (uptrend! = old & & uptrend == false)
         {
           val2 [i] = low; // if the conditions are fulfilled then draw val1
           if (i == 0) GlobalVariableSet ("goSELL", 1);
         }
 
       if (uptrend! = old & & uptrend == true)
         {
           val1 [i] = high; // if the conditions are fulfilled then draw val2
           if (i == 0) GlobalVariableSet ("goBUY", 1);
         }
//----
       if (uptrend2! = old2 & & uptrend2 == true)
         {
           valX1 [i] = smax2; // if the conditions are fulfilled then draw valX1
           if (i == 0) GlobalVariableSet ("stBUY", 1);
         }
       if (uptrend2! = old2 & & uptrend2 == false)
         {
           valX2 [i] = smin2; // if the conditions are fulfilled then draw valX2
           if (i == 0) GlobalVariableSet ("stSELL", 1);
         }
//-----------------------
       old = uptrend;
       old2 = uptrend2;
//-----------------------
       BufferH [i] = smax;
       BufferL [i] = smin;
       BufferHS [i] = smax2;
       BufferLS [i] = smin2;
     }
   return (0);
  }
// ------------------------------------------------ ------------------